export interface IBuildConfig {
    env: 'production' | 'development';
    for: string;
    entryPoints: {
        [key: string]: string[];
    };
    internals: RegExp[];
    externals: RegExp[];
    outTargetName: string;
    outputDirPath: string;
    projectBaseDir: string;
    moduleAliases: {
        [key: string]: string;
    };
    explainErrors: boolean;
    envVars: {
        [key: string]: string;
    };
}
export declare const generateBabelConfig: (shitSupport: boolean) => {
    presets: (string | {
        targets: string;
        modules: boolean;
        useBuiltIns: string;
        corejs: number;
        shippedProposals?: undefined;
    } | {
        targets: {
            browsers: string;
            node: string;
        };
        shippedProposals: boolean;
        modules: boolean;
        useBuiltIns?: undefined;
        corejs?: undefined;
    })[][];
    plugins: any[];
};
export default function mkConfig(config: IBuildConfig): Promise<{
    target: string;
    node: {
        __dirname: boolean;
        __filename: boolean;
    };
    module: {
        rules: any[];
        unknownContextCritical: boolean;
    };
    experiments: {
        mjs: boolean;
        asyncWebAssembly: boolean;
        importAwait: boolean;
        importAsync: boolean;
        topLevelAwait: boolean;
    };
    devtool: string;
    entry: {};
    resolve: {
        alias: {
            [x: string]: string;
        };
        extensions: string[];
        modules: string[];
        mainFields: any[];
        symlinks: boolean;
    };
    output: any;
    plugins: any[];
    externals: string[];
    stats: {
        errorDetails: boolean;
    };
    cache: boolean;
    parallelism: number;
    mode: string;
    optimization: {
        chunkIds: string;
        moduleIds: string;
        mangleExports: boolean;
        removeAvailableModules: boolean;
        removeEmptyChunks: boolean;
        mergeDuplicateChunks: boolean;
        flagIncludedChunks: boolean;
        sideEffects: boolean;
        providedExports: boolean;
        usedExports: boolean;
        concatenateModules: boolean;
        noEmitOnErrors: boolean;
        portableRecords: boolean;
        minimize: boolean;
        minimizer: any[];
        splitChunks: {
            chunks: string;
            maxInitialRequests: number;
            maxAsyncRequests: number;
            maxSize: number;
        };
        runtimeChunk: string | boolean;
    };
}>;
